<?php

    class Enable_Event_Chain_Action extends Reactor_Action
    {
        protected $tpl = 'enable_event_chain.php';
        protected $name = 'Enable an event chain';
		
		public static $registration = array(
			ACTION_NAME => 'Enable an event chain',
			ACTION_CATEGORY => 'Nagios Reactor',
			ACTION_DESCRIPTION => 'Enables an event chain.',
			ACTION_AUTHOR => 'Jeremy Yunis, Nagios Enterprises, LLC',
			ACTION_VERSION => '1.0',
			ACTION_DATE => '03/15/2013', //Last version update
			ACTION_AUTHLEVEL => 1,  // 0 - everyone | 1 - Admin only
			ACTION_TYPE => 'core', //core | user. core modules can't be deleted
			ACTION_META => array(),	//Misc information
		);
		
        protected $fields = array(
            'chain_identifier' => array(
                'label' => 'event chain identifier',
                'validate' => 'trim|required|xss_clean|prep_for_form',
            ),
        );

        public function get_label()
        {
            if($params = $this->get_params()) {
                if(array_key_exists('chain_identifier', $params)) {
                    return sprintf('Enable event chain \'%s\'', $params['chain_identifier']);
                }
            }
            return parent::get_label();
        }
       
        public function run($context)
        {
            $this->set_context($context);
            $params = $this->get_params();
            $success = FALSE;
            if(array_key_exists('chain_identifier', $params)) {
                $slug = $params['chain_identifier'];
                $this->log('info', 'enabling an event chain with in identifier of '. $slug);
                if($chain_row = $this->ci->event_chain_model->get($slug)) {
                    $chain_row->update(array('active' => TRUE));
                    $success = TRUE;
               }
            }
            $this->set_result(($success) ? 0 : 1);
            return $context;
        }

    }
